.nolist
#define TASM
#define bcall(xxxx)     rst 28h \ .dw xxxx
#define equ .equ
#define    LCDDelay()   .db $DB,$10,$87,$38,$FB
_RclAns         equ 4AD7h
_ChkFindSym     equ 42F1h
_DispHL         equ 4507h
_AnsName        equ 4B52h
_ClearOP1       equ 41C5h
GraphBuf        equ 9340h
PBuf            equ 86ECh
.list
        .org 9D93h
        .db $BB,$6D
        bcall(_AnsName)
        rst 10h
        ex de,hl
        ld c,(hl)
        inc hl
        ld b,(hl)
        ld de,1
        or a
        jr z,RealInput
        dec a
        jr z,ListInput
        sub 11
        jr z,ComplexInput
        dec a
        ret nz
ComplexListInput:
        sla c \ rl b
ListInput:
        inc hl
        jr SetUp
ComplexInput:
        ld e,2
RealInput:
        ld b,d \ ld c,e
        dec hl
SetUp:
      in a,(2)                ;DB02        use to get the model
      rrca                    ;07          to put bit 7 in bit 0
      and 1                   ;E601        masks out all bits except bit 0. This tells if the model can use 15MHz
      out (20h),a             ;D320        if a is 1, sets to 15MHz, if a is 0, sets 6MHz.
      ld (ArgLoc),hl
      ld (ArgCount),bc
      di
CommandStart:
      call LoadIncrement
      ret z
      ld hl,CommandStart \ push hl
      ld b,a
Command0:                   ;ClearAllParticles
     or a \ jr nz,Command1
     ld hl,0
     ld (PBuf),hl
     ret
Command1:                   ;ExecParticleLoop
     djnz Command2
     ld bc,(PBuf)
     ld hl,PBuf+2
StartPLoop:
       ld a,b \ or c \ ret z
       push bc
       push hl
       ld c,(hl) \ inc hl
       ld b,(hl)
;pixel off       
       push bc
       call GetPixelLoc
       pop bc
       jr nc,$+5
       cpl \ and (hl) \ ld (hl),a

       inc c
       push bc
       call GetPixelLoc
       and (hl)
       pop bc
       jr z,EndPLoop
       dec c \ push bc
       ld a,r \ and 2 \ dec a \ add a,b \ ld b,a
       push bc
       call GetPixelLoc
       pop bc
       pop de
       and (hl)
       jr z,EndPLoop
       ld b,d \ ld c,e
EndPLoop:
       pop hl
       ld (hl),c \ inc hl
       ld (hl),b \ inc hl
       push hl
       call GetPixelLoc
       jr nc,$+4
       or (hl) \ ld (hl),a
       pop hl
       pop bc
       dec bc
       jr StartPloop
Command2:
     djnz Command3
     ld hl,(PBuf)
     ld bc,383
     sbc hl,bc \ add hl,bc \ ret z
     inc hl \ ld (PBuf),hl
     ld bc,PBuf
     add hl,hl
     add hl,bc
     push hl
     Call LoadIncrement
     push de
     call LoadIncrement
     pop bc
     pop hl
     ld (hl),c \ inc hl
     ld (hl),a
     ld b,a
     call GetPixelLoc
     or (hl) \ ld (hl),a
     ret
Command3:
;     djnz Command4
;     ld hl,PBuf+1
;     ld a,(hl) \ dec hl
;     or (hl) \ ret z
;     dec (hl) \ ret nz
;     inc hl
;     dec (hl) \ ret
Command4:
     bcall(486Ah)
     ret
GetPixelLoc:
;Input:
;     b is X
;     c is C
;Output:
;     HL points to byte
;     A is the mask
;     nc if not computed, c if computed
       ld a,c
       cp 64 \ ret nc
       ld a,b
       cp 96 \ ret nc
       ld l,c
       ld h,0
       ld b,h
       add hl,hl
       add hl,bc
       add hl,hl
       add hl,hl
       ld b,a
       rrca \ rrca \ rrca
       and 0Fh
       ld c,a
       ld a,b
       ld b,0
       add hl,bc
       ld bc,GraphBuf
       add hl,bc
       and 7
       ld b,a
       inc b
       ld a,1
         rrca
         djnz $-1
       scf
       ret
HL_Times_A:
       ex de,hl
DE_Times_A:
       ld b,8
       ld hl,0
         add hl,hl
         rlca
         jr nc,$+3
           add hl,de
         djnz $-5
       ret
LoadIncrement:
     .db 11h
ArgLoc:
     .dw 0
     .db 21h
ArgCount:
     .dw 0
     ld a,h
     or l
     jr nz,$+5
       ld d,a
       ld e,a
       ret
     dec hl
     ld (ArgCount),hl
     ex de,hl
     call ConvDecAtHL
     ld (ArgLoc),hl
     or 1
     ld a,e
     ret
ConvSupplement: 
     push de
     push hl
     call HL_Times_A
     ld de,(Word1)
     add hl,de
     ld (Word1),hl
     pop hl
     ld a,10
     call HL_Times_A
     pop de
     ret
Conv_OP1:
     ld hl,8478h
ConvDecAtHL:
     ld a,(hl) \ rlca \ push af \ inc hl
     ld a,(hl)
     push hl
     and 0Fh
     srl a
     push af
     inc a
     ld c,a
     ld b,0
     add hl,bc
     ex de,hl
     ld h,b
     ld l,b
     ld (Word1),hl
     inc hl
     pop af
     jr nc,$+8
       ld a,(de)
       and 0Fh
       call ConvSupplement
     ld a,(de)
     and $F0
     rlca \ rlca \ rlca \ rlca
     call ConvSupplement
     dec de
     dec c
     ld a,c
     or a
     jr nz,$-20
     pop hl
     ld de,8
     add hl,de
     .db 11h
Word1:
     .dw 0

     pop af
     jr nc,NotNegative
       push hl
       ld hl,0
       sbc hl,de
       ex de,hl
       pop hl
NotNegative:
     ld a,e
     ret

.end